#ifndef __CCARD_INCLUDED__
#define __CCARD_INCLUDED__

#include <allegro.h>
#include "Fire.h"
#include "Smoke.h"


class CCard
{
protected:
	enum STATE
	{
		BACKSIDE	= 0,
		FLIPTOFRONT,
		FRONTSIDE,
		FLIPTOBACK,
		BURNING,
		SMOKING,
		VANISHED
	};

public:
	static bool cheat;

	CCard(void);
	virtual ~CCard(void);

	inline void SetBackside(BITMAP* backside) {m_backside = backside;};
	inline void SetFrontside(BITMAP* frontside) {m_frontside = frontside;};
	inline void SetPosition(int x, int y) {m_x = x; m_y = y;};

	inline void SetIndex(int index) {m_index = index;};
	inline int GetIndex(void) {return m_index;};

	bool PointOnCard(int x, int y);

	void Update(void);
	void Draw(BITMAP* dest);

	inline bool IsClosed(void)  {return m_state == BACKSIDE;};
	inline bool IsOpen(void)  {return m_state != BACKSIDE;};
	inline bool IsVisible(void) {return m_state != VANISHED;};
	inline bool IsRemoved(void) {return m_state == VANISHED;};
	inline bool IsBurning(void) {return m_state != BURNING;};
	inline bool IsSmoking(void) {return m_state != SMOKING;};
	inline bool IsBackside(void) {return m_state != BACKSIDE;};
	inline bool IsFrontside(void) {return m_state != FRONTSIDE;};
	inline bool IsIdle(void) {return m_state == FRONTSIDE || m_state == BACKSIDE || m_state == VANISHED;};

	void Open(void);
	void Close(void);
	void Remove(void);

protected:
	int m_index;			// two cards have same index to match
	BITMAP* m_backside;
	BITMAP* m_frontside;
	float m_flip_progress;
	int m_x;
	int m_y;
	STATE m_state;
	int m_counter;
	CFire * m_fire;
	CSmoke* m_smoke;
};

#endif

