#ifndef __CCARDSTACK_INCLUDED__
#define __CCARDSTACK_INCLUDED__

#include <allegro.h>
#include "Card.h"

#define NUMBER_OF_CARDS 16
#define NUMBER_OF_PAIRS (NUMBER_OF_CARDS/2)

class CCardStack
{
public:
	CCardStack(void);
	virtual ~CCardStack(void);

	// Mix cards and set them up
	void CreateNewStack(void);

	void Update(void);
	void Draw(BITMAP* dest);

	void LoadDatafile(const char * filename);

	int GetCardIndexAtPoint(int x, int y);
	CCard* GetCard(int index);

	bool OpenCard(int index);
	int GetNumCardsOpen(void) {return m_num_open_cards;};

	void CloseAllCards(void);
	bool AreAllCardsRemoved(void);
	bool AllCardsIdle(void);
	bool DoOpenCardsMatch(void);
	void RemoveOpenCards(void);

private:
	void DeleteAllCards(void);
	CCard * m_card[NUMBER_OF_CARDS];		// 16 Cards in the Game, makes 8 pairs

	DATAFILE* m_datafile;

	int m_num_open_cards;
	int m_open_cards[2];
};



#endif
