#include "Data.h"

#include <string>


//static 
DATAFILE* CData::datafile;


//static
void CData::Load(const char* filename)
{
	CData::datafile = load_datafile(filename);
	if(NULL == CData::datafile)
	{
		throw std::string("Failed loading datafile ") + filename;
	}
}

//static 
void CData::Unload(void)
{
	if(CData::datafile)
	{
		unload_datafile(CData::datafile);
		CData::datafile = NULL;
	}
}

//static 
BITMAP* CData::GetBitmap(int id)
{
	if(NULL == CData::datafile)
	{
		throw std::string("No datafile loaded!");
	}
	void* dat = (DATAFILE*)CData::datafile[id].dat;
	if(dat == NULL)
	{
		throw std::string("Data Object (bmp) not found!");
	}
	return (BITMAP*) dat;
}

//static 
FONT* CData::GetFont(int id)
{
	if(NULL == CData::datafile)
	{
		throw std::string("No datafile loaded!");
	}
	void* dat = (DATAFILE*)CData::datafile[id].dat;
	if(dat == NULL)
	{
		throw std::string("Data Object (font) not found!");
	}
	return (FONT*) dat;
}
