#ifndef __CDISPLAY_INCLUDED__
#define __CDISPLAY_INCLUDED__

#include <allegro.h>

class CDisplay
{
public:
	enum MODE
	{
		NOINIT			= 0,
		BACKBUFFER		= 1,
		DOUBLEBUFFER	= 2
	};

	CDisplay(void);
	CDisplay(MODE mode, int w, int h, int depth = 0, int rate = 60, bool windowed = true);
	void InitInstance(void);
	virtual ~CDisplay(void);

	void Init(MODE mode, int w, int h, int depth = 0, int rate = 60, bool windowed = true);
	void DeInit(void);

	inline BITMAP* Buffer(void) { return m_buffer[m_used_buffer]; };
	
	inline int W(void)	{ return m_w; };
	inline int H(void)	{ return m_h; };
	inline int Depth(void)	{ return m_depth; };

	BITMAP* BeginUpdate(void);
	void EndUpdate(void);

private:
	void SaveScreenshot(BITMAP * src);


	BITMAP* m_buffer[3];
	int m_w;
	int m_h;
	int m_depth;
	MODE m_mode;
	int m_used_buffer;

	bool m_screenshot_taken;
};

extern CDisplay * Display;

#endif

