#ifndef __GAMESCREEN_INCLUDED__
#define __GAMESCREEN_INCLUDED__

#include <allegro.h>
#include <string>

#include "Display.h"
#include "Player.h"
#include "Cardstack.h"
#include "Message.h"


class CGameScreen
{
public:
	CGameScreen(void);
	virtual ~CGameScreen(void);

	void Start(void);
	
	void Update(void);
	void Draw(BITMAP* dest);

	inline bool Finished(void) {return m_finished;};

private:
	void DrawPlayerDeco(BITMAP* dest);
	bool CheckTrashcanClick(void);

	enum STATE
	{
		START   = 0,
		WAITSTART,
		WAITRULES,
		INIT,
		CHANGEPLAYER,
		WAITPLAYER,
		SELECTCARD,
		WAITCARD,
		CHECKCARDS,
		DELAYCLOSECARDS,
		WAITCARDSCLOSED,
		WAITREMOVECARDS,
		CHECKGAMEEND,
		PRESENTWINNER,
		WAITQUIT
	};

	CPlayer m_player[2];
	CCardStack m_cardstack;

	bool m_finished;
	int m_act_player;
	STATE m_state;
	int m_counter;

	BITMAP* m_bmp_pipe_h;
	BITMAP* m_bmp_pipe_v;
	BITMAP* m_bmp_pipe_bend_1;
	BITMAP* m_bmp_pipe_bend_2;
	BITMAP* m_bmp_pipe_bend_3;
	BITMAP* m_bmp_pipe_bend_4;
	BITMAP* m_bmp_pipe_junc_1;
	BITMAP* m_bmp_pipe_junc_2;

	BITMAP* m_bmp_title;
	BITMAP* m_bmp_trashcan;
	int m_trashcan_x;
	int m_trashcan_y;

	CMessage* m_message;

};




#endif

