#ifndef __CMESSAGE_INCLUDED__
#define __CMESSAGE_INCLUDED__


#include <allegro.h>
#include <string>
#include <list>

class CMessage
{
private:
	CMessage(void);

public:
	CMessage(int x, int y, int w, int h, const char * text);
	virtual ~CMessage(void);

	void Update(void);
	void Draw(BITMAP* dest);

	inline bool Finished(void) {return m_finished;};

private:
	bool m_finished;
	FONT* m_font;
	int m_text_color;
	int m_bg_color;
	int m_bg_intensity;

	int m_x;
	int m_y;
	int m_w;
	int m_h;

	std::list<std::string> m_lines;

	BITMAP* m_bmp_pipe_h;
	BITMAP* m_bmp_pipe_v;
	BITMAP* m_bmp_pipe_bend_1;
	BITMAP* m_bmp_pipe_bend_2;
	BITMAP* m_bmp_pipe_bend_3;
	BITMAP* m_bmp_pipe_bend_4;
};



#endif

