#include "Mouse.h"


CMouse * Mouse;


CMouse::CMouse(void)
{
	m_x = 0;
	m_y = 0;
	m_buttons = 0;
	m_last_buttons = 0;
	m_button_pressed = 0;
	m_button_released = 0;
	m_z = 0;
	m_last_z = 0;
}

CMouse::~CMouse(void)
{
}


void CMouse::Update(void)
{
	poll_mouse();
	m_x = mouse_x;
	m_y = mouse_y;

	m_last_buttons = m_buttons;
	m_buttons = mouse_b;
	m_button_pressed = (m_last_buttons ^ m_buttons) & m_buttons;
	m_button_released = (m_last_buttons ^ m_buttons) & m_last_buttons;

	m_last_z = m_z;
	m_z = mouse_z;
	m_delta_z = m_z - m_last_z;
}

void CMouse::Draw(BITMAP* dest)
{
	draw_sprite(dest, mouse_sprite, m_x, m_y);
}


bool CMouse::ButtonUp(int nr)
{
	return !(m_buttons & (1 << nr));
}

bool CMouse::ButtonDown(int nr)
{
	return (bool)(m_buttons & (1 << nr));
}

bool CMouse::ButtonPressed(int nr)
{
	return (bool)(m_button_pressed & (1 << nr));
}

bool CMouse::ButtonReleased(int nr)
{
	return (bool)(m_button_released & (1 << nr));
}

