#ifndef __CMOUSE_INCLUDED__
#define __CMOUSE_INCLUDED__

#include <allegro.h>


class CMouse
{
public:
	CMouse(void);
	virtual ~CMouse(void);

	void Update(void);
	void Draw(BITMAP* dest);

	inline int X(void) { return m_x; };
	inline int Y(void) { return m_y; };

	bool ButtonUp(int nr);
	bool ButtonDown(int nr);
	bool ButtonPressed(int nr);
	bool ButtonReleased(int nr);

	inline int DeltaZ(void) { return m_delta_z; };

private:
	int m_x;
	int m_y;
	int m_buttons;
	int m_last_buttons;
	int m_button_pressed;
	int m_button_released;
	int m_z;
	int m_last_z;
	int m_delta_z;

};


extern CMouse * Mouse;

#endif
