#include "Player.h"
#include "Data.h"

#define _USE_MATH_DEFINES
#include <math.h>


#define HIGHLIGHT_STEP  (M_PI / 100.0f)
#define HIGHLIGHT_DEPTH  0.075f

CPlayer::CPlayer(void) : m_name("Player")
{
	m_pairs = 0;
	m_x = 0;
	m_y = 0;
	m_w = 0;
	m_h = 0;
	m_highligh = false;
	m_highlight_pos = 0.0f;
	m_back_color = makecol(128,128,128);
	m_name_color = makecol(50,70,210);
	m_pairs_txt_color = makecol(100,100,160);
	m_pairs_color = makecol(193,66,123);
	m_fnt_name = CData::GetFont(FNT_COPPER_12);
}

CPlayer::~CPlayer(void)
{
}

void CPlayer::Update(void)
{
	if(m_highligh)
	{
		m_highlight_pos += HIGHLIGHT_STEP;
		if(m_highlight_pos >= M_PI * 2.0f) m_highlight_pos = 0.0f;
	}
}

void CPlayer::DrawInfo(BITMAP* dest)
{
	int x_center = m_x + (m_w >>1);
	int y = m_y + (m_h - 5 * text_height(m_fnt_name)) / 2;

	int color = m_back_color;
	int color_frame = 0;
	
	if(m_highligh)
	{
		int r = getr(color);
		int g = getg(color);
		int b = getb(color);
		float f = 1.0 + sinf(m_highlight_pos) * HIGHLIGHT_DEPTH;
		r = MAX(MIN((int)((float)r * f ), 255), 0);
		g = MAX(MIN((int)((float)g * f ), 255), 0);
		b = MAX(MIN((int)((float)b * f ), 255), 0);
		color = makecol(r,g,b);
		color_frame = makecol((int)(128.0f * f), 0, 0);
	}

	rectfill(dest, m_x, m_y, m_x + m_w -1, m_y + m_h - 1, color);
	textout_centre_ex(dest, m_fnt_name, m_name.c_str(), x_center, y, m_name_color, -1);
	y += 2 * text_height(m_fnt_name);
	textout_centre_ex(dest, m_fnt_name, "pairs", x_center, y, m_pairs_txt_color, -1);
	y += text_height(m_fnt_name);
	textprintf_centre_ex(dest, m_fnt_name, x_center, y, m_pairs_color, -1, "%d", m_pairs);

	if(m_highligh)
	{
		rect(dest, m_x + 20, m_y + 10, m_x + m_w - 21, m_y + m_h - 11, color_frame);
	}
}

