#ifndef __CPLAYER_INCLUDED__
#define __CPLAYER_INCLUDED__

#include <allegro.h>
#include <string>


class CPlayer
{
public:
	CPlayer(void);
	virtual ~CPlayer(void);

	void Update(void);
	void DrawInfo(BITMAP* dest);

	inline void SetName(const std::string & name) {m_name = name;};
	inline std::string &GetName(void) {return m_name;};

	inline void SetInfoPos(int x, int y) {m_x = x; m_y = y;};
	inline void SetInfoSize(int w, int h) {m_w = w; m_h = h;};
	inline void SetInfoBackColor(int color) {m_back_color = color;};

	inline void AddPair(int count = 1) {m_pairs += count;};
	inline int GetPairs(void) {return m_pairs;};
	inline void SetPairs(int count = 0) {m_pairs = count;};

	inline void Highlight(bool highlight) { m_highligh = highlight; m_highlight_pos = 0.0f;};

private:
	std::string m_name;		// Name, for further use, now Player 1 or Player 2
	int m_pairs;			// Number of pairs removed
	int m_x;
	int m_y;
	int m_w;
	int m_h;
	int m_back_color;
	int m_name_color;
	int m_pairs_txt_color;
	int m_pairs_color;
	float m_highlight_pos;
	bool m_highligh;

	FONT* m_fnt_name;

};



#endif

