#ifndef __CSMOKE_INCLUDED__
#define __CSMOKE_INCLUDED__

#include <allegro.h>
#include <string>
#include <list>

class CSmoke;

class CCloud
{
public:
	enum DRIFTDIR
	{
		NONE = 0,
		LEFT,
		RIGHT
	};
public:
	friend class CSmoke;

	static void InitBmp(void);
	static void CleanupBmp(void);

	CCloud(void);
	CCloud(int x, int y, DRIFTDIR driftdir, float driftscale);
	virtual ~CCloud(void);

	void Update(void);
	void Draw(BITMAP* dest);
	
	inline bool IsAlive(void) {return m_alive;};

protected:
	static const int num_of_cloud_bmps = 5;
	static BITMAP* cloud_bmp[CCloud::num_of_cloud_bmps];
	float m_x;
	float m_y;
	float m_scale;
	float m_intense;
	float m_speed;
	float m_drift;
	float m_drift_scale;
	bool m_alive;
	DRIFTDIR m_driftdir;
};


class CSmoke
{
public:
	CSmoke(void);
	CSmoke(int x, int y, int w);

	virtual ~CSmoke(void);

	void Update(void);
	void Draw(BITMAP* dest);

	bool IsFinished();

protected:
	static const int MAX_CLOUDS = 70;

	std::list<CCloud*> m_cloud_list;

	int m_created_clouds;
	int m_next_cloud_delay;
	int m_x;
	int m_y;
	int m_w;
};


#endif

