#include "Timer.h"


#include <allegro.h>

//static 
volatile int CTimer::ticker = 0;

//static 
int CTimer::ticker_bps = 0;

//static 
volatile int CTimer::fps_counter = 0;
//static 
int CTimer::fps_act = 0;



//static 
void CTimer::TickerCallback(void)
{
	++CTimer::ticker;
}
END_OF_FUNCTION(CTimer::TickerCallback)

//static 
void CTimer::FpsCallback(void)
{
	CTimer::fps_act = CTimer::fps_counter;
	CTimer::fps_counter = 0;
}
END_OF_FUNCTION(CTimer::FpsCallback)

//static 
void CTimer::StartTicker(int hz)
{
	LOCK_VARIABLE(CTimer::ticker);
	LOCK_FUNCTION(TickerCallback);

	if(install_int_ex(TickerCallback, BPS_TO_TIMER(hz)) < 0)
	{
		throw std::string("Timer could not be added!");
	}
	CTimer::ticker = 0;
	CTimer::ticker_bps = hz;
}

//static 
void CTimer::StartFpsTimer(void)
{
	LOCK_VARIABLE(CTimer::fps_counter);
	LOCK_FUNCTION(FpsCallback);

	if(install_int_ex(FpsCallback, BPS_TO_TIMER(1)) < 0)
	{
		throw std::string("Fps Timer could not be added!");
	}
	CTimer::fps_counter = 0;
	CTimer::fps_act = 0;
}

