#ifndef __CTIMER_INCLUDED__
#define __CTIMER_INCLUDED__

#include <string>

class CTimer
{
private:
	static volatile int ticker;
	static int ticker_bps;

	static volatile int fps_counter;
	static int fps_act;

	CTimer(void)	// private constructor -> no instances
	{
		throw std::string("Timer is a static class. No instances please");
	};
	virtual ~CTimer(void){};

	static void TickerCallback(void);
	static void FpsCallback(void);

public:
	static void StartTicker(int hz);
	static void StartFpsTimer(void);

	inline static void AdvanceFps(void) {++CTimer::fps_counter;};
	inline static int GetFps(void) {return CTimer::fps_act;};

	inline static int  GetTicker(void){return CTimer::ticker;};
	inline static void DecTicker(void){if(CTimer::ticker > 0) --CTimer::ticker;};
	inline static void ResetTicker(void){CTimer::ticker = 0;};
	inline static int  GetTickerBps(void){return CTimer::ticker_bps;};



};



#endif
